#include <yasapi.h>

static gboolean hide_widget_asynchronous (gpointer widget)
{
  gtk_widget_hide (widget);

  return FALSE;
}

int main (int argc, char **argv)
{
  Player player;
  HRESULT hr;
  int c;

  hr=CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);

  if (FAILED(hr)) {
    DVMESSAGE("CoInitializeEx() failed with 0x%p",hr);
    goto ecoinit;
  }

  if (PlayerCreate(&player,NULL)<0) {
    DMESSAGE("creating player");
    goto ewasapi;
  }

  for (;;) {
    c=fgetc(stdin);

    switch (c) {
    case 'x':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      goto end;
    case '+':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      PlayerShow(&player,&player.gtk.about,NULL);
      break;
    case '-':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      g_idle_add (hide_widget_asynchronous, player.gtk.about.window);
      break;
    case '*':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      PlayerShow(&player,&player.gtk.config,NULL);
      break;
    case '/':
      fprintf (stdout, "'%c' received\n", c); fflush (stdout);
      g_idle_add (hide_widget_asynchronous, player.gtk.config.window);
      break;
    default:
      break;
    }
  }
end:
  PlayerDestroy(&player);
ewasapi:
  CoUninitialize();
ecoinit:
  return 0;
}
