/*
 * yasapi_api.h
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __YASAPI_API_H__ // [
#define __YASAPI_API_H__
#ifdef __cplusplus // [
extern "C" {
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_EXPORT) // [
#undef YASAPI_EXPORT
#define YASAPI_EXPORT __declspec (dllexport)
#else // ] [
#define YASAPI_EXPORT __declspec (dllimport)
#endif // ]

///////////////////////////////////////////////////////////////////////////////
typedef enum _YasapiApiVersion YasapiApiVersion;
typedef struct _YasapiApi YasapiApi;
typedef const YasapiApi *(GetYasapiApiFun)(void);

///////////////////////////////////////////////////////////////////////////////
enum _YasapiApiVersion {
  eYasapiApiVersion=1
};

///////////////////////////////////////////////////////////////////////////////
struct _YasapiApi {
  // available with version 1 of the api:
  int (*GetVersion)(void);
  int (*GetLatency)(void);
  int (*WaitForWriting)(int msTimeout, const char *buf, int len);
  int (*WaitForEndOfTrack)(int msTimeout);
  void (*KillWaiting)(void);
  // available with version 2 of the api:
};

///////////////////////////////////////////////////////////////////////////////
YASAPI_EXPORT GetYasapiApiFun GetYasapiApi;

#ifdef __cplusplus // [
}
#endif // ]
#endif // __YASAPI_API_H__ ]
