/*
 * yasapi_config_label.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>

static void LabelSet(ConfigWidget *pWidget)
{
  Dialog *pDialog=pWidget->pDialog;
  char **pValue=(char **)pWidget->pCell->nav(pDialog,pWidget->pCell->offs);
  GtkWidget *widget = pWidget->widget;

  if (!pValue) {
    DVWRITELN("*** %s pValue=NULL",pWidget->pCell->pId);
    gtk_label_set_text (GTK_LABEL (widget), "");
  }
  else if (!*pValue) {
    DVWRITELN("*** %s *pValue=NULL",pWidget->pCell->pId);
    gtk_label_set_text (GTK_LABEL (widget), "");
  }
  else {
    DVWRITELN("*** %s pValue=\"%s\"",pWidget->pCell->pId,*pValue);
    gtk_label_set_text (GTK_LABEL (widget), *pValue);
  }
}

static void LabelGet(ConfigWidget *pWidget)
{
}

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="Label",
#endif // ]
    .set=LabelSet,
    .get=LabelGet,
  };

  GtkWidget *widget = gtk_label_new(NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);
  pExpand->h=0;
  pExpand->v=0;

  return widget;
}

IClassCellVtbl gcIClassLabelVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="Label",
#endif // ]
  .create=ClassLabelCreate,
};
