/*
 * yasapi_config_label_device.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>
#include <yasapi_config.h>

static void ConfigLabelDeviceSet(ConfigWidget *pWidget)
{
  Dialog *pDialog=pWidget->pDialog;
  Wasapi *pWasapi=PlayerWasapi(pDialog->pGtk->pPlayer);
  WasapiDevice *pDeviceConfig=pWasapi->selected.pDeviceConfig;

#if defined (YASAPI_DEVICE_MARKUP) // [
  gtk_label_set_markup (GTK_LABEL (pWidget->widget),
      pDeviceConfig->pFriendlyNameMarkup);
#else // ] [
  gtk_label_set_text (GTK_LABEL (pWidget->widget),
      pDeviceConfig->pFriendlyName);
#endif // ]
}

static void ConfigLabelDeviceGet(ConfigWidget *pWidget)
{
}

static GtkWidget *ConfigLabelDeviceCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="LabelDevice",
#endif // ]
    .set=ConfigLabelDeviceSet,
    .get=ConfigLabelDeviceGet,
  };

  GtkWidget *widget = gtk_label_new (NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelDeviceVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="ComboBoxDevice",
#endif // ]
  .create=ConfigLabelDeviceCreate,
};
