/*
 * yasapi_config_label_dword.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>

static void LabelDWordSet(ConfigWidget *pWidget)
{
  Dialog *pDialog=pWidget->pDialog;
  const char *format=pWidget->pCell->data;
  DWORD *pdwValue=(DWORD *)pWidget->pCell->nav(pDialog,pWidget->pCell->offs);
  GtkWidget *widget = pWidget->widget;
  char buf[32];

  if (pdwValue) {
    sprintf (buf,format?format:"%lu",pdwValue?*pdwValue:88888ul);
    DVWRITELN("*** \"%s\"",buf);
    gtk_label_set_text (GTK_LABEL (widget), buf);
  }
}

static void LabelDWordGet(ConfigWidget *pWidget)
{
}

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelDWordCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="LabelDWord",
#endif // ]
    .set=LabelDWordSet,
    .get=LabelDWordGet,
  };

  GtkWidget *widget = gtk_label_new(NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelDWordVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelDWord",
#endif // ]
  .create=ClassLabelDWordCreate,
};
