/*
 * yasapi_config_label_engine_latency.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>
#include <yasapi.h>

static void LabelEngineLatencySet(ConfigWidget *pWidget)
{
  Player *pPlayer=pWidget->pDialog->pGtk->pPlayer;
  Engine *pEngine=&pPlayer->engine;
  char buf[128];

  if (eEngineNull==pEngine->eState)
    goto exit;

  sprintf(buf,"%u Frames@%lu Hz ≈ %u ms ",pEngine->stats.uNumFramesMax,
      pEngine->wfx.Format.nSamplesPerSec,pEngine->stats.uMsLatencyMax);
  gtk_label_set_text (GTK_LABEL (pWidget->widget), buf);
exit:
  return;
}

static void LabelEngineLatencyGet(ConfigWidget *pWidget)
{
}

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelEngineLatencyCreate(ClassCell *pCell,
    Dialog *pDialog, Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="LabelEngineLatency",
#endif // ]
    .set=LabelEngineLatencySet,
    .get=LabelEngineLatencyGet,
  };

  GtkWidget *widget = gtk_label_new(NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelEngineLatencyVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelEngineLatency",
#endif // ]
  .create=ClassLabelEngineLatencyCreate,
};
