/*
 * yasapi_config_label_mapped.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>

static void ConfigLabelMappedSet(ConfigWidget *pWidget)
{
  ClassCell *pCell=pWidget->pCell;
  int *value=(int *)pCell->nav(pWidget->pDialog,pCell->offs);
  ConfigComboBoxMap *map;

//DVWRITELN("%s - %d",pWidget->pCell->pId,*value);
  for (map=pCell->data;map->label;++map) {
//DVWRITELN("%s - %d %s",pWidget->pCell->pId,map->value,map->label_em);
    if (map->value==*value) {
//DVWRITELN("%s - fire!!!",pWidget->pCell->pId);
      gtk_label_set_markup (GTK_LABEL (pWidget->widget), map->label_em);
      return;
    }
  }
}

static void ConfigLabelMappedGet(ConfigWidget *pWidget)
{
}

static GtkWidget *ConfigLabelMappedCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="LabelMapped",
#endif // ]
    .set=ConfigLabelMappedSet,
    .get=ConfigLabelMappedGet,
  };

  GtkWidget *widget = gtk_label_new (NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelMappedVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelMapped",
#endif // ]
  .create=ConfigLabelMappedCreate,
};
