/*
 * yasapi_config_label_static.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelStaticCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  GtkWidget *widget;

  widget = gtk_label_new (NULL);

#if defined (YASAPI_DEVICE_MARKUP) // [
  gtk_label_set_markup (GTK_LABEL (widget), pCell->data);
#else // ] [
  gtk_label_set_text (GTK_LABEL (widget), pCell->data);
#endif // ]
  ConfigWidgetCreate(pCell, pDialog, NULL, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelStaticVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelStatic",
#endif // ]
  .create=ClassLabelStaticCreate,
};

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelStaticFunCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  typedef int (fun_t)(Dialog *pDialog, char *buf, size_t size);
  char buf[32];

  ((fun_t *)pCell->data)(pDialog, buf, sizeof buf);

  return gtk_label_new (buf);
}

IClassCellVtbl gcIClassLabelStaticFunVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelStaticFun",
#endif // ]
  .create=ClassLabelStaticFunCreate,
};
