/*
 * yasapi_config_label_uint32.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>
#include <stdint.h>

static void LabelUint32Set(ConfigWidget *pWidget)
{
  Dialog *pDialog=pWidget->pDialog;
  const char *format=pWidget->pCell->data;
  UINT32 *puValue=(UINT32 *)pWidget->pCell->nav(pDialog,pWidget->pCell->offs);
  GtkWidget *widget = pWidget->widget;
  char buf[128];

  if (puValue&&*puValue<UINT32_MAX) {
    sprintf (buf,format?format:"%u",*puValue);
    gtk_label_set_text (GTK_LABEL (widget), buf);
  }
  else
    gtk_label_set_text (GTK_LABEL (widget), "");
}

static void LabelUint32Get(ConfigWidget *pWidget)
{
}

///////////////////////////////////////////////////////////////////////////////
static GtkWidget *ClassLabelUint32Create(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  static IConfigWidgetVtbl vtbl={
#if defined (YASAPI_DEBUG) // [
    .pId="LabelUint32",
#endif // ]
    .set=LabelUint32Set,
    .get=LabelUint32Get,
  };

  GtkWidget *widget = gtk_label_new(NULL);

  ConfigWidgetCreate(pCell, pDialog, &vtbl, widget);

  return widget;
}

IClassCellVtbl gcIClassLabelUint32Vtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="LabelUint32",
#endif // ]
  .create=ClassLabelUint32Create,
};
