/*
 * yasapi_config_notebook.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi_config.h>

static GtkWidget *ClassNotebookCreate(ClassCell *pCell, Dialog *pDialog,
    Expand *pExpand)
{
  ClassNotebookPage *pPage;
  GtkWidget *notebook,*label,*page;
  Expand e;

  pDialog->notebook = notebook = gtk_notebook_new ();

  for (pPage=pCell->data;pPage->label.lpVtbl&&pPage->page.lpVtbl;++pPage) {
    pCell=&pPage->label;
    label = pCell->lpVtbl->create(pCell,pDialog,&e);

    pCell=&pPage->page;
    e.h = FALSE;
    e.v = FALSE;
    page = pCell->lpVtbl->create(pCell,pDialog,&e);

    g_object_set (G_OBJECT (page), "margin", ePanelSpace, NULL);

    if (e.h) {
      gtk_widget_set_hexpand (page, TRUE);
      gtk_widget_set_halign (page, GTK_ALIGN_FILL);
    }
    else
      gtk_widget_set_halign (page, GTK_ALIGN_CENTER);

    if (e.v) {
      gtk_widget_set_vexpand (page, TRUE);
      gtk_widget_set_valign (page, GTK_ALIGN_FILL);
    }
    else
      gtk_widget_set_valign (page, GTK_ALIGN_CENTER);

    gtk_notebook_append_page (GTK_NOTEBOOK (notebook), page, label);
  }

  pExpand->h = TRUE;
  pExpand->v = TRUE;

  return notebook;
}

IClassCellVtbl gcIClassNotebookVtbl={
#if defined (YASAPI_DEBUG) // [
  .pId="Notebook",
#endif // ]
  .create=ClassNotebookCreate,
};
