/*
 * yasapi_defines.h
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __YASAPI_DEFINES_H__ // [
#define __YASAPI_DEFINES_H__

#ifdef __cplusplus // [
extern "C" {
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#if ! defined (YASAPI_MAJOR) // [
#define YASAPI_MAJOR 0
#endif // ]

#if ! defined (YASAPI_MINOR) // [
#define YASAPI_MINOR 0
#endif // ]

#if ! defined (YASAPI_BUILD) // [
#define YASAPI_BUILD 0
#endif // ]

#if ! defined (YASAPI_BETA) // [
#define YASAPI_BETA 0
#endif // ]

#define YASAPI_MIN_VERSION(major,minor,beta) ( \
  ((major)<YASAPI_MAJOR) || ((major)==(YASAPI_MAJOR)) && ( \
    ((minor)<YASAPI_MINOR) || ((minor)==(YASAPI_MINOR)) && ( \
      0==(YASAPI_BETA) || (beta)<=(YASAPI_BETA) \
    ) \
  ) \
)

///////////////////////////////////////////////////////////////////////////////
//#define YASAPI_DEBUG
//#define YASAPI_ABOUT_TEXT_VIEW
#define YASAPI_DEVICE_MARKUP
//#define YASAPI_ENGINE_REGISTER_WHEN_STARING
//#define YASAPI_PRODUCTBUILD
//#define YASAPI_PLAYBACK_BEGIN_MIN_NUM_CHUNKS

#if defined (_MSC_VER) // [
//#define YASAPI_FILE_OPEN_DIALOG
#endif // ]

#if ! defined (YASAPI_DEBUG) // [
#define YASAPI_AV_THREAD_CHARACTERISTICS
#endif // ]

#if 0 && YASAPI_MIN_VERSION(2,1,1) // [
#define YASAPI_FORMAT_CONVERTION_WHILE_READING
#endif // ]

#if YASAPI_MIN_VERSION(2,1,1) // [
#define YASAPI_OPTION_VOLUME
#endif // ]

#if defined (YASAPI_OPTION_VOLUME) // [
#if YASAPI_MIN_VERSION(2,1,2) // [
#define YASAPI_SIMPLE_AUDIO_VOLUME
#endif // ]

#if YASAPI_MIN_VERSION(2,1,3) // [
#define YASAPI_AUDIO_ENDPOINT_VOLUME
#endif // ]

#if defined (YASAPI_SIMPLE_AUDIO_VOLUME) \
    || defined (YASAPI_AUDIO_ENDPOINT_VOLUME) // [
#define YASAPI_VOLUME_WASAPI
#endif // ]
#endif // ]

#if YASAPI_MIN_VERSION(2,2,0) // [
#define YASAPI_OPTION_GAPLESS
#endif // ]

#if defined (_MSC_VER) // [
///////////////////////////////////////////////////////////////////////////////
#define __func__ __FUNCTION__
#endif // ]

///////////////////////////////////////////////////////////////////////////////
// https://gustedt.wordpress.com/2010/06/16/associativity-of-double-constants-and-preprocessor-tokens/
#define YASAPI_PASTE2(a, b) \
  a ## b
#define _YASAPI_PASTE2(a, b) \
  YASAPI_PASTE2(a, b)
#define YASAPI_PASTE3(a, b, c) \
  _YASAPI_PASTE2(YASAPI_PASTE2(a, b), c)
#define YASAPI_PASTE4(a, b, c, d) \
  _YASAPI_PASTE2(YASAPI_PASTE3(a, b, c), d)
#define YASAPI_PASTE5(a, b, c, d, e) \
  _YASAPI_PASTE2(YASAPI_PASTE4(a, b, c, d), e)
#define YASAPI_PASTE6(a, b, c, d, e, f) \
  _YASAPI_PASTE2(YASAPI_PASTE5(a, b, c, d, e), f)

#define _YASAPI_STRA(id) \
    #id
#define YASAPI_STRA(id) \
    _YASAPI_STRA(id)
#define _YASAPI_STRW(id) \
    L ## #id
#define YASAPI_STRW(id) \
    _YASAPI_STRW(id)

#define YASAPI_ARRAYSIZE(a) \
    (sizeof (a))/(sizeof (a)[0])

///////////////////////////////////////////////////////////////////////////////
#define YASAPI_VERSION \
    YASAPI_PASTE5(YASAPI_MAJOR,.,YASAPI_MINOR,.,YASAPI_BUILD)

#if defined (__GNUC__) // [
#define YASAPI_TITLE_SFX " (gcc)"
#define YASAPI_TITLE_SFX_U8 " (gcc)"
#define YASAPI_TITLE_SFX_U16 L" (gcc)"
#elif defined (_MSC_VER) // ] [
#define YASAPI_TITLE_SFX " (msc)"
#define YASAPI_TITLE_SFX_U8 " (msc)"
#define YASAPI_TITLE_SFX_U16 L" (msc)"
#else // ] [
#define YASAPI_TITLE_SFX ""
#define YASAPI_TITLE_SFX_U8 ""
#define YASAPI_TITLE_SFX_U16 L""
#endif // ]

#if defined (YASAPI_BETA) && 0<YASAPI_BETA // [
#define YASAPI_VERSION_SFX "-beta" YASAPI_STRA(YASAPI_BETA)
#define YASAPI_VERSION_SFX_U8 "-\316\262" YASAPI_STRA(YASAPI_BETA)
#define YASAPI_VERSION_SFX_U16 L"-\x03B2" YASAPI_STRW(YASAPI_BETA)
#else // ] [
#define YASAPI_VERSION_SFX ""
#define YASAPI_VERSION_SFX_U8 ""
#define YASAPI_VERSION_SFX_U16 L""
#endif // ]

#define YASAPI_VERSION_CS YASAPI_STRA(YASAPI_VERSION) YASAPI_VERSION_SFX
#define YASAPI_VERSION_U8 YASAPI_STRA(YASAPI_VERSION) YASAPI_VERSION_SFX_U8
#define YASAPI_VERSION_U16 YASAPI_STRW(YASAPI_VERSION) YASAPI_VERSION_SFX_U16

#define YASAPI_TITLE "YASAPI/NT Output v" YASAPI_VERSION_CS \
    YASAPI_TITLE_SFX
#define YASAPI_TITLE_U8 "YASAPI/NT Output v" YASAPI_VERSION_U8 \
    YASAPI_TITLE_SFX_U8
#define YASAPI_TITLE_U16 L"YASAPI/NT Output v" YASAPI_VERSION_U16 \
    YASAPI_TITLE_SFX_U16

///////////////////////////////////////////////////////////////////////////////
#define DMESSAGE(format) \
    yasapi_message(__FILE__,__LINE__,format,0ul)
/*
#define DMESSAGESYS(format) \
    yasapi_message(__FILE__,__LINE__,format,GetLastError())
*/
#define DVMESSAGE(format,...) \
    yasapi_message(__FILE__,__LINE__,format,0ul,__VA_ARGS__)
/*
#define DVMESSAGEW(format,...) \
    yasapi_messagew(__FILE__,__LINE__,format,0ul,__VA_ARGS__)
#define DVMESSAGESYS(format,...) \
    yasapi_message(__FILE__,__LINE__,format,GetLastError(),__VA_ARGS__)
*/
#define DCMESSAGE(m,label) case label: \
    DMESSAGE(m " failed with " #label); \
    break
#define DVCMESSAGE(m,label,...) case label: \
    DVMESSAGE(m " failed with " #label,__VA_ARGS__); \
    break
#define DDMESSAGE(m,hr) default: \
    DVMESSAGE(m " failed with unknown %p",hr); \
    break
#define DVDMESSAGE(m,hr,...) default: \
    DVMESSAGE(m " failed with unknown %p",__VA_ARGS__,hr); \
    break

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_DEBUG) // [
#define DBASENAME(path) \
  yasapi_basenamea (path)
#define DMARKLN() do { \
  fprintf(stderr,"[%s:%d:%s]\n",DBASENAME(__FILE__),__LINE__,__func__); \
  fflush (stderr); \
} while (0)
#define DWRITELN(line) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fputs(line,stderr); \
  fputs("\n",stderr); \
  fflush(stderr); \
} while (0)
#define DWRITELNW(line) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fputws(line,stderr); \
  fputs("\n",stderr); \
  fflush(stderr); \
} while (0)
#define DVWRITELN(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DVWRITELNW(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fwprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DVWRITELNW(format,...) do { \
  fprintf(stderr,"[%s:%d:%s] ",DBASENAME(__FILE__),__LINE__,__func__); \
  fwprintf(stderr,format,__VA_ARGS__); \
  fputs("\n",stderr); \
  fflush (stderr); \
} while (0)
#define DASSERT(condition,label) do { \
  if (!(condition)) { \
    DMESSAGE(YASAPI_STRA(condition) " does not hold"); \
    goto label; \
  } \
} while (0)
#define DSLEEP(ms) \
  Sleep(ms)
#define DGETC() \
  fgetc(stdin)
#else // ] [
#define DMARKLN()
#define DWRITELN(s)
#define DWRITELNW(s)
//#define DWRITELN(format,...)
#define DVWRITELN(format,...)
//#define DWRITELNW(format,...)
#define DVWRITELNW(format,...)
#define DASSERT(confition,label)
#define DGETC()
#define DSLEEP(ms)
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#define YASAPI_FRAMES2MS(uNumFrames,pwfx) \
  (1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_FRAMES2HNS(uNumFrames,pwfx) \
  (10.0*1000.0*1000.0*(uNumFrames)/(pwfx)->Format.nSamplesPerSec)
#define YASAPI_SIZE2FRAMES(dwSize,pwfx) \
  MulDiv(1,dwSize,(pwfx)->Format.nBlockAlign)

#ifdef __cplusplus // [
}
#endif // ]
#endif // __YASAPI_DEFINES_H__ ]
