/*
 * yasapi_message.c
 *
 * Yet Another (WA)SAPI (YASAPI) NT Output Plugin for Winamp (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

void yasapi_message(const char *file, int line, const char *format,
    DWORD dwLastError, ...)
{
  char buf[128],*bp=buf;
  int nButton;
  va_list ap;

  file=yasapi_basenamea(file);
  bp+=sprintf(bp,"[%s:%d] Error ",file,line);
  va_start(ap,dwLastError);
  bp+=vsprintf(bp,format,ap);
  va_end(ap);

  if (0ul<dwLastError)
    switch (dwLastError) {
    case ERROR_INVALID_HANDLE:
      bp+=sprintf(bp,"\n[%s:%d] ERROR_INVALID_HANDLE.",
          file,line);
      break;
    default:
      bp+=sprintf(bp,"\n[%s:%d] System error: 0x%p/%lu.",
          file,line,(void *)dwLastError,dwLastError);
      break;
    }
    else {
      *bp++='.';
      *bp=0;
    }

#if defined (YASAPI_DEBUG) // [
  *bp++='\n';
  *bp=0;
  fputs(buf,stderr);
  fflush(stderr);
  --bp;
#endif // ]
  *bp=0;

  nButton=MessageBoxA(
    NULL,                       // _In_opt_ HWND    hWnd,
    buf,                        // _In_opt_ LPCTSTR lpText,
    YASAPI_TITLE " Error",      // _In_opt_ LPCTSTR lpCaption,
    MB_OKCANCEL|MB_ICONERROR|MB_SYSTEMMODAL|MB_TOPMOST
                                // _In_     UINT    uType
  );

  if (IDOK==nButton)
    ExitProcess(0);
}
