/*
 * yasapi_ring_plain.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2015-2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

///////////////////////////////////////////////////////////////////////////////
#if defined (YASAPI_ID) // [
#undef YASAPI_ID
#endif // ]
#define YASAPI_ID Plain

#define YASAPI_ID_IRING_VTBL() \
  YASAPI_PASTE3(gcIRing,YASAPI_ID,Vtbl)
#define YASAPI_ID_RING(id) \
  YASAPI_PASTE3(Ring,YASAPI_ID,id)
#define YASAPI_ID_RING_SOURCE(id) \
  YASAPI_PASTE4(Ring,YASAPI_ID,Source,id)
#define YASAPI_ID_RING_TARGET(id) \
  YASAPI_PASTE4(Ring,YASAPI_ID,Target,id)

///////////////////////////////////////////////////////////////////////////////
static DWORD YASAPI_ID_RING_SOURCE(ConvertSize)(Ring *pRing, DWORD dwSize)
{
  return dwSize;
}

static DWORD YASAPI_ID_RING_SOURCE(Size)(Ring *pRing)
{
  return RingPlainSourceConvertSize(pRing,pRing->_mp-pRing->_buf);
}

static DWORD YASAPI_ID_RING_SOURCE(Written)(Ring *pRing)
{
  return RingPlainSourceConvertSize(pRing,pRing->_dwWritten);
}

static DWORD YASAPI_ID_RING_SOURCE(Available)(Ring *pRing)
{
  return RingPlainSourceConvertSize(pRing,pRing->_dwAvailable);
}

////////////////
static DWORD YASAPI_ID_RING_TARGET(ConvertSize)(Ring *pRing, DWORD dwSize)
{
  return dwSize;
}

static DWORD YASAPI_ID_RING_TARGET(Size)(Ring *pRing)
{
  return pRing->_mp-pRing->_buf;
}

static DWORD YASAPI_ID_RING_TARGET(Written)(Ring *pRing)
{
  return pRing->_dwWritten;
}

#if defined (YASAPI_TARGET_AVAILABLE) // [
static DWORD YASAPI_ID_RING_TARGET(Available)(Ring *pRing)
{
  return pRing->_dwAvailable;
}
#endif // ]

////////////////
static BYTE *YASAPI_ID_RING(Buf2Ring)(Ring *pRing, BYTE *dst,
		const BYTE *src, DWORD dwSize)
{
  return memcpy(dst,src,dwSize);
}

////////////////
IRingVtbl YASAPI_ID_IRING_VTBL()={
#if defined (YASAPI_SOURCE_CONVERT_SIZE) // [
  .source.ConvertSize=YASAPI_ID_RING_SOURCE(ConvertSize),
#endif // ]
  .source.Size=YASAPI_ID_RING_SOURCE(Size),
  .source.Written=YASAPI_ID_RING_SOURCE(Written),
  .source.Available=YASAPI_ID_RING_SOURCE(Available),
  ////////////
  .target.ConvertSize=YASAPI_ID_RING_TARGET(ConvertSize),
  .target.Size=YASAPI_ID_RING_TARGET(Size),
  .target.Written=YASAPI_ID_RING_TARGET(Written),
#if defined (YASAPI_TARGET_AVAILABLE) // [
  .target.Available=YASAPI_ID_RING_TARGET(Available),
#endif // ]
  ////////////
  .Buf2Ring=YASAPI_ID_RING(Buf2Ring),
};
