/*
 * yasapi_trace.c
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#include <yasapi.h>

#if defined (YASAPI_DEBUG) // [
int TraceCreate(Trace *pTrace, Out_Module *pOut)
{
  if (pOut) {
    if (0!=(pTrace->bConsole=AllocConsole())) {
      freopen("conin$", "r", stdin);
      freopen("conout$", "w", stdout);
      freopen("conout$", "w", stderr);
      DWRITELN("Console allocated.");
    }
  }
  else
    pTrace->bConsole=0;

  return 0;
}

void TraceDestroy(Trace *pTrace)
{
  enum { eMs=5000 };

  if (pTrace->bConsole) {
    //DVWRITELN("Sleeping %d ms ...",eMs);
    //Sleep(eMs);
    DWRITELN("Hit some key ...");
    DGETC();
    FreeConsole();
  }
}
#endif // ]
